import pickle
import sys
import os
from Log import Log

def createShortName(longName):
	nameSplit = longName.split(" ")
	shortName = nameSplit[0][0] +"."+nameSplit[1][:2]
	for x in nameSplit[2:]:
		shortName += "_" + x
	return shortName

########## Read arg's ##########
if len(sys.argv) == 1:
	print("Aggregator.py Classification [-l lookFor] DomainName")
	print("Classification\tHK, HHK, RR, Spo0A")
	print("DomainName\tMistDB Domain Architecture Name")
	print("lookFor\tA MistDB Domain Architecture Name that must be colocated with DomainName")
	quit()
else:
	classification = sys.argv[1]
	if "-l" in sys.argv:
		lookout = True
		lookFor = sys.argv[3]
		domain = sys.argv[4]
	else:
		lookout = False
		domain = sys.argv[2]

########## Collect meta data, init Log ##########
speciesList = [x for x in os.listdir(os.getcwd()) if os.path.isdir(x)]
log = Log(classification+"-"+domain, ending="fasta")

########## Aggregate sequences ##########
if classification in ["HK", "HHK", "RR"]:
	print("Read species pickles -- " + domain)
	domainList = []
	for species in speciesList:
		print(species)
		os.chdir(species)
		
		# Find correct .pkl
		try:
			pklFile = [x for x in os.listdir(os.getcwd()) if x.endswith("-"+classification+".pkl")][0]
			print(pklFile)
		except:
			os.chdir("..")
			continue
		domainDict = pickle.load(open(pklFile, 'rb'))
		
		# Grab relevant seq's
		for protID in domainDict:
			found = False
			temp = ""
			for domains in domainDict[protID]['proteins']:
				if lookout:
					if domains[0][1] == lookFor:
						found = True
					if domains[0][1] == domain and not found:
						temp = domains[3][1]
					if domains [0][1] == domain and found:
						domainList.append((domainDict[protID]['locus'], domains[3][1]))
						break
					if found and temp != "":
						domainList.append((domainDict[protID]['locus'], temp))
						break
				else:
					if domains[0][1] == domain:
						domainList.append((domainDict[protID]['locus'], domains[3][1]))
		
		os.chdir("..")
	
	print("Writing "+log.getName())
	for x in domainList:
		log.add(">"+x[0])
		log.add(x[1])
		log.add("")
	log.close()
	print("SUCCESS!")
