from html.parser import HTMLParser

class mistDBParser(HTMLParser):
	def __init__(self, GetNextPages=True):
		self.reset()
		self.inTable = False
		self.inLabel = False
		self.skipLabel = False
		self.lookForID = False
		self.IDIsNext = False
		self.getPages = False
		self.inMap = False
		self.lastProtID = ""
		self.lastProtLocus = ""
		self.prot = {}
		self.pageLinks = set()
		
		self.getNextPages = GetNextPages
	
	def handle_starttag(self, tag, attrs):
		# Turn on flag for getting new pages
		if self.getNextPages and tag == "div":
			for t in attrs:
				if t[0] == "class" and t[1] == "middle_section":
					self.getPages = True
		# Get links if looking for other pages
		elif self.getPages and tag == "a":
			self.pageLinks.add(attrs[0][1])
		# Turn on table flag
		elif tag == "table":
			self.inTable = True
			return
		# Data capture mode/flag
		if self.inTable:
			if tag == "td":
				for t in attrs:
					if "class" in t and t[1] == "right":
						self.skipLabel = True
			elif self.inTable and self.lookForID and tag == "a":
				self.IDIsNext = True
			elif tag == "label":
				if self.skipLabel:
					self.skipLabel = False
					self.lookForID = True
				else:
					for t in attrs:
						if "for" in t and t[1].find("CartGeneIds") != -1:
							self.inLabel = True
			elif tag == "map":
				self.inMap = True
		
		
	def handle_endtag(self, tag):
		if tag == "table":
			self.inTable = False
		elif tag == "map":
			self.inMap = False
		elif self.getPages and tag == "div":
			self.getPages = False
		
	def handle_startendtag(self, tag, attrs):
		if self.inTable and self.inMap and tag == "area":
			start, stop, name, seq = (), (), (), ()
			for t in attrs:
				if t[0] == "data-start":
					start = ("start", t[1])
				elif t[0] == "data-stop":
					stop = ("stop", t[1])
				elif t[0] == "data-name":
					name = ("name", t[1])
				elif t[0] == "data-sequence":
					seq = ("seq", t[1])
			self.prot[self.lastProtID]["locus"] = self.lastProtLocus
			self.prot[self.lastProtID]["proteins"].append((name, start, stop, seq))
			
		
	def handle_data(self, data):
		if self.inTable and self.inLabel:
			self.lastProtLocus = data
			self.inLabel = False
		elif self.inTable and self.lookForID and self.IDIsNext:
			self.lastProtID = data
			self.prot[data] = {"locus": "", "proteins": []}
			self.lookForID = False
			self.IDIsNext = False