class Log:
	"""A simple text logger."""
	
	filePtr = None
	stage = []
	
	def __init__(self, logName, ending="txt"):
		if logName.find(":") != -1:
			logName = logName.replace(":", "")
		self.filePtr = open(logName + "." + ending, 'w')
	
	def add(self, line, newLine=True):
		"""Add a line to the log's staging area."""
		if newLine:
			self.stage.append(line + "\n")
		else:
			self.stage.append(line)
	
	def remove(self):
		"""Remove the last line from the log's staging area."""
		if len(self.stage) > 0:
			del self.stage[-1]
	
	def clearStage(self):
		"""Clear all lines from the staging area."""
		self.stage = []
	
	def flush(self):
		"""Write the staging area to disk."""
		for item in self.stage:
			self.filePtr.write(item)
	
	def close(self):
		"""Flush the stage and close the file."""
		self.flush()
		self.filePtr.close()
	
	def getName(self):
		return self.filePtr.name