from CustomParser import mistDBParser
from Log import Log
import urllib.request as req
import sys
import pickle

# Read arg's
if len(sys.argv) == 1:
	print("MistParser.py WebAddress Filename")
	print("WebAddress\tfully-qualified web address (http://mistdb.com/...)")
	print("Filename\t filename for results to be written to")
	quit()
else:
	initLink = sys.argv[1]
	outFilename = sys.argv[2]

# Open initial page and parse
print("Requesting page: " + initLink)
f = req.urlopen(initLink)
data = f.read().decode("utf-8")
print("Reading data...")
mist = mistDBParser()
mist.feed(data)
proteins = mist.prot.copy()

# Open and parse all following pages
for link in mist.pageLinks:
	print("Requesting page: http://mistdb.com" + link)
	page = req.urlopen("http://mistdb.com" + link.replace(' ', '+'))
	text = page.read().decode("utf-8")
	print("Reading data...")
	mist2 = mistDBParser(False)
	mist2.feed(text)
	proteins.update(mist2.prot)

print("Writing data to " + outFilename + ".txt")
l = Log(outFilename)
for id in proteins.keys():
	l.add("> " + str(id) + " " + str(proteins[id]["locus"]))
	for item in proteins[id]["proteins"]:
		l.add(str(item[0][1]) + "\t" + str(item[1][1]) + "\t" + str(item[2][1]) + "\t" + str(item[3][1]))
	l.add("")
l.close()

print("Pickling data to " + outFilename + ".pkl")
pickle.dump(proteins, open(outFilename + '.pkl', 'wb'))
